Index: cli.c
===================================================================
--- cli.c	(revision 7663)
+++ cli.c	(working copy)
@@ -946,6 +946,20 @@
 
 static int handle_help(int fd, int argc, char *argv[]);
 
+static char * complete_help(char *text, char *word, int pos, int state)
+{
+	/* skip first 4 or 5 chars, "help "*/
+	int l = strlen(text);
+
+	ast_log(LOG_WARNING, "pos %d state %d text <%s> word <%s>\n",
+		pos, state, text, word);
+	if (l > 5)
+		l = 5;
+	text += l;
+	/* XXX watch out, should stop to the non-generator parts */
+	return __ast_cli_generator(text, word, state, 0); /* XXX maybe last arg. should be 1 ? */
+}
+
 static struct ast_cli_entry builtins[] = {
 	/* Keep alphabetized, with longer matches first (example: abcd before abc) */
 	{ { "_command", "complete", NULL }, handle_commandcomplete, "Command complete", commandcomplete_help },
@@ -953,8 +967,8 @@
 	{ { "_command", "matchesarray", NULL }, handle_commandmatchesarray, "Returns command matches array", commandmatchesarray_help },
 	{ { "debug", "channel", NULL }, handle_debugchan, "Enable debugging on a channel", debugchan_help, complete_ch_3 },
 	{ { "debug", "level", NULL }, handle_debuglevel, "Set global debug level", debuglevel_help },
	{ { "group", "show", "channels", NULL }, group_show_channels, "Show active channels with group(s)", group_show_channels_help},
-	{ { "help", NULL }, handle_help, "Display help list, or specific help on a command", help_help },
+	{ { "help", NULL }, handle_help, "Display help list, or specific help on a command", help_help, complete_help },
 	{ { "load", NULL }, handle_load, "Load a dynamic module by name", load_help, complete_fn },
 	{ { "no", "debug", "channel", NULL }, handle_nodebugchan, "Disable debugging on a channel", nodebugchan_help, complete_ch_4 },
 	{ { "reload", NULL }, handle_reload, "Reload configuration", reload_help, complete_mod_2 },
